diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
index 060ab63f3..d6dc143ed 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
@@ -1,8 +1,7 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicSpikes;
@@ -18,7 +17,7 @@ public class BlockModelSpikes<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         int metaData = worldSource.getBlockData(tilePos);
         IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.EAST, metaData);
         if (renderBlocks.overrideBlockTexture != null) {
@@ -28,13 +27,7 @@ public class BlockModelSpikes<T extends BlockLogic> extends BlockModelStandard<T
         renderBlocks.renderStandardBlock(tessellator, worldSource, this, new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 0.1875F, 1.0F), tilePos);
 
         if (BlockLogicSpikes.isSpikesUp(metaData)) {
-            float brightness = 1.0f;
-            if (LightmapHelper.isLightmapEnabled()) {
-                tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
-            } else {
-                brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-            }
-            tessellator.setColorOpaque_F(brightness, brightness, brightness);
+            tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
             double uMin = texture.getIconUMin();
             double uMax = texture.getIconUMax();
             double vMin = texture.getIconVMin();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
index 4d04daa49..3716fbe19 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicStairs;
 import net.minecraft.core.util.helper.Side;
@@ -12,7 +12,6 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStandard<T> {
@@ -35,7 +34,7 @@ public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStan
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         int meta = worldSource.getBlockData(tilePos);
         int hRotation = meta & 0b0011;
         int vRotation = meta & 0b1000;
@@ -69,14 +68,10 @@ public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStan
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        if (renderBlocks.useInventoryTint) {
-            int j = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
-            float f1 = (float) (j >> 16 & 0xff) / 255F;
-            float f3 = (float) (j >> 8 & 0xff) / 255F;
-            float f5 = (float) (j & 0xff) / 255F;
-            GL11.glColor4f(f1 * brightness, f3 * brightness, f5 * brightness, alpha);
-        }
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        tessellator.offsetTranslation(-0.5, -0.5, -0.5);
+        tessellator.startDrawingQuads();
+        tessellator.setColor1i(getStandaloneTintColor(metadata));
         for (int l = 0; l < 2; l++) {
             AABBdc bounds;
             if (l == 0) {
@@ -84,39 +79,27 @@ public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStan
             } else {
                 bounds = new AABBd(0.5F, 0.5F, 0.0F, 1.0F, 1.0F, 1.0F);
             }
-            GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
-            tessellator.startDrawingQuads();
+
             tessellator.setNormal(0.0F, -1F, 0.0F);
             renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 1.0F, 0.0F);
             renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, -1F);
             renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, 1.0F);
             renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(-1F, 0.0F, 0.0F);
             renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(1.0F, 0.0F, 0.0F);
             renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
-            tessellator.draw();
-
-            GL11.glTranslatef(0.5F, 0.5F, 0.5F);
         }
+        tessellator.draw();
+        tessellator.offsetTranslation(0.5, 0.5, 0.5);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
index cba9efab6..c53be41f5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
@@ -15,7 +15,6 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.DisplayPos;
 
 import java.util.Arrays;
@@ -62,7 +61,7 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T> {
     }
 
     @Override
-    public boolean renderNoCulling(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean renderNoCulling(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         renderBlocks.renderAllFaces = true;
         boolean result = render(tessellator, worldSource, tilePos);
         renderBlocks.renderAllFaces = false;
@@ -70,7 +69,7 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T> {
     }
 
     @Override
-    public boolean renderWithOverrideTexture(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, IconCoordinate textureIndex) {
+    public boolean renderWithOverrideTexture(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, IconCoordinate textureIndex) {
         renderBlocks.overrideBlockTexture = textureIndex;
         boolean result = render(tessellator, worldSource, tilePos);
         renderBlocks.overrideBlockTexture = null;
@@ -78,12 +77,12 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T> {
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         return renderBlocks.renderStandardBlock(tessellator, worldSource, this, this.block.getBoundsFromState(worldSource, tilePos), tilePos);
     }
 
     @Override
-    public boolean renderOverbright(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean renderOverbright(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         renderBlocks.overbright = true;
         boolean result = render(tessellator, worldSource, tilePos);
         renderBlocks.overbright = false;
@@ -91,30 +90,17 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T> {
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        if (renderBlocks.useInventoryTint) {
-            int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
-            float r = (float) (color >> 16 & 0xff) / 255F;
-            float g = (float) (color >> 8 & 0xff) / 255F;
-            float b = (float) (color & 0xff) / 255F;
-            GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
-        } else {
-            GL11.glColor4f(brightness, brightness, brightness, alpha);
-        }
-        float yOffset = 0.5F;
-
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
         AABBdc bounds = getBlockBoundsForItemRender();
-        GL11.glTranslatef(-0.5F, 0.0F - yOffset, -0.5F);
-        renderBlockWithBounds(tessellator, bounds, metadata, brightness, alpha, lightmapCoordinate);
-        GL11.glTranslatef(0.5F, yOffset, 0.5F);
+        tessellator.offsetTranslation(-0.5, -0.5, -0.5);
+        renderBlockWithBounds(tessellator, bounds, metadata, lightmapCoord, getStandaloneTintColor(metadata));
+        tessellator.offsetTranslation(0.5F, 0.5, 0.5F);
     }
 
-    public void renderBlockWithBounds(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        if (LightmapHelper.isLightmapEnabled() && lightmapCoordinate != null) {
-            LightmapHelper.setLightmapCoord(lightmapCoordinate);
-        }
-
+    public final void renderBlockWithBounds(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, int metadata, int lightmapCoord, int color) {
         tessellator.startDrawingQuads();
+        tessellator.setLightmapCoord1i(lightmapCoord);
+        tessellator.setColor1i(color);
 
         tessellator.setNormal(0.0f, -1.0f, 0.0f);
         renderBlocks.renderBottomFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
@@ -134,31 +120,8 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T> {
         tessellator.setNormal(1.0f, 0.0f, 0.0f);
         renderBlocks.renderEastFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
 
-        tessellator.draw();
-
-        if (LightmapHelper.isLightmapEnabled() && lightmapCoordinate != null) {
-            LightmapHelper.setLastLightmapCoord();
-        }
-
         if (hasOverbright()) {
-//			GL11.glDisable(GL11.GL_LIGHTING);
-
-            float brightnessOver = 1.0f;
-            if (renderBlocks.useInventoryTint) {
-                int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
-                float r = (float) (color >> 16 & 0xff) / 255F;
-                float g = (float) (color >> 8 & 0xff) / 255F;
-                float b = (float) (color & 0xff) / 255F;
-                GL11.glColor4f(r * brightnessOver, g * brightnessOver, b * brightnessOver, alpha);
-            } else {
-                GL11.glColor4f(brightnessOver, brightnessOver, brightnessOver, alpha);
-            }
-
-            if (LightmapHelper.isLightmapEnabled()) {
-                LightmapHelper.setLightmapCoord(15, 15);
-            }
-
-            tessellator.startDrawingQuads();
+            tessellator.setLightmapCoord2i(15, 15);
 
             tessellator.setNormal(0.0f, -1.0f, 0.0f);
             renderBlocks.renderBottomFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.BOTTOM, metadata));
@@ -178,14 +141,8 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T> {
             tessellator.setNormal(1.0f, 0.0f, 0.0f);
             renderBlocks.renderEastFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.EAST, metadata));
 
-            tessellator.draw();
-
-            if (LightmapHelper.isLightmapEnabled()) {
-                LightmapHelper.setLastLightmapCoord();
-            }
-
-//			GL11.glEnable(GL11.GL_LIGHTING);
         }
+        tessellator.draw();
     }
 
     @Override
@@ -221,6 +178,13 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T> {
         return getBlockOverbrightTextureFromSideAndMeta(side, source.getBlockData(tilePos));
     }
 
+    public int getStandaloneTintColor(int metadata) {
+        if (renderBlocks.useInventoryTint) {
+            return (BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0) & 0xFFFFFF) | 0xFF000000;
+        }
+        return 0xFFFFFFFF;
+    }
+
     @Override
     public boolean hasOverbright() {
         return this.overbrightTextures.hasTexture();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
index 176048d57..2d9079661 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
@@ -1,17 +1,16 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
 
 public class BlockModelStoneMossy<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate mossOverlay;
@@ -22,7 +21,7 @@ public class BlockModelStoneMossy<T extends BlockLogic> extends BlockModelStanda
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         AABBdc bounds = this.block.getBoundsFromState(worldSource, tilePos);
         renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos, 1.0f, 1.0f, 1.0f);
         renderBlocks.overrideBlockTexture = this.mossOverlay;
@@ -32,45 +31,37 @@ public class BlockModelStoneMossy<T extends BlockLogic> extends BlockModelStanda
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
         renderBlocks.useInventoryTint = false;
-        super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
+        super.renderStandalone(tessellator, metadata, lightmapCoord);
         renderBlocks.useInventoryTint = true;
-        GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
         int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
-        float r = (float) (color >> 16 & 0xff) / 255F;
-        float g = (float) (color >> 8 & 0xff) / 255F;
-        float b = (float) (color & 0xff) / 255F;
-        GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
 
         AABBdc bounds = this.block.getBounds();
         IconCoordinate mossCoord = this.mossOverlay;
 
+        tessellator.offsetTranslation(-0.5, -0.5, -0.5);
         tessellator.startDrawingQuads();
+        tessellator.setColor1i(color);
         tessellator.setNormal(0.0F, -1F, 0.0F);
         renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
-        tessellator.draw();
-        tessellator.startDrawingQuads();
+
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
         renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
-        tessellator.draw();
-        tessellator.startDrawingQuads();
+
         tessellator.setNormal(0.0F, 0.0F, -1F);
         renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
-        tessellator.draw();
-        tessellator.startDrawingQuads();
+
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
         renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
-        tessellator.draw();
-        tessellator.startDrawingQuads();
+
         tessellator.setNormal(-1F, 0.0F, 0.0F);
         renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
-        tessellator.draw();
-        tessellator.startDrawingQuads();
+
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
         renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
         tessellator.draw();
-        GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+        tessellator.offsetTranslation(0.5, 0.5, 0.5);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
index 3c8aad47b..5f8ee000f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicTorch;
@@ -17,17 +17,10 @@ public class BlockModelTorch<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         float brightness = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
-        } else {
-            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-            if (this.block.emission > 0) {
-                brightness = 1.0F;
-            }
-        }
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
+        tessellator.setColorOpaque3f(brightness, brightness, brightness);
         double d = 0.4;
         double d1 = 0.5D - d;
         double d2 = 0.2;
@@ -52,7 +45,7 @@ public class BlockModelTorch<T extends BlockLogic> extends BlockModelStandard<T>
         return true;
     }
 
-    public void renderTorchAtAngle(Tessellator tessellator, double x, double y, double z, double topOffsetX, double topOffsetZ) {
+    public void renderTorchAtAngle(TessellatorTerrain tessellator, double x, double y, double z, double topOffsetX, double topOffsetZ) {
         IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.BOTTOM, 0);
         if (renderBlocks.overrideBlockTexture != null) {
             texture = renderBlocks.overrideBlockTexture;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
index 66be3fbd1..04d44863e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
@@ -1,7 +1,8 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicTrapDoor;
@@ -12,7 +13,6 @@ import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 
 public class BlockModelTrapDoor<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelTrapDoor(Block<T> block) {
@@ -22,7 +22,7 @@ public class BlockModelTrapDoor<T extends BlockLogic> extends BlockModelStandard
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         int metadata = worldSource.getBlockData(tilePos);
         boolean isUp = BlockLogicTrapDoor.isTrapdoorOpen(metadata);
 
@@ -70,14 +70,15 @@ public class BlockModelTrapDoor<T extends BlockLogic> extends BlockModelStandard
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        GL11.glTranslatef(0, 0.25f, 0);
-        super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        tessellator.offsetTranslation(0, 0.25, 0);
+        super.renderStandalone(tessellator, metadata, lightmapCoord);
+        tessellator.offsetTranslation(0, -0.25, 0);
     }
 
     @Override
     public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
-        int orientation = data & 3;
+        int orientation = data & 0b11;
         if (BlockLogicTrapDoor.isTrapdoorOpen(data)) {
             int index = Sides.orientationLookUpTrapdoorOpen[6 * orientation + side.getId()];
             return this.blockTextures.get(index);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
index 84eb9d1ae..f8c54a8d2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
@@ -27,7 +28,7 @@ public class BlockModelVeryRotatable<T extends BlockLogic> extends BlockModelSta
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         final int meta = worldSource.getBlockData(tilePos);
         final Direction dir = BlockLogicVeryRotatable.metaToDirection(meta);
 
@@ -48,10 +49,10 @@ public class BlockModelVeryRotatable<T extends BlockLogic> extends BlockModelSta
 
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
         renderBlocks.uvRotateTop = 1;
         renderBlocks.uvRotateBottom = 1;
-        super.renderStandalone(tessellator, 3, brightness, alpha, lightmapCoordinate);
+        super.renderStandalone(tessellator, 3, lightmapCoord);
         renderBlocks.resetRenderBlocks();
     }
 
@@ -67,42 +68,26 @@ public class BlockModelVeryRotatable<T extends BlockLogic> extends BlockModelSta
 
     public Side getRotatedSide(Side side, int data) {
         final Direction dir = BlockLogicVeryRotatable.metaToDirection(data);
-        switch (dir) { // I love brute forcing fixes so much :3
-            case SOUTH:
-                return side;
-            case EAST:
-                return side.getDirection().rotate(1).getSide();
-            case NORTH:
-                return side.getDirection().rotate(2).getSide();
-            case WEST:
-                return side.getDirection().rotate(3).getSide();
-            case UP:
-                switch (side) {
-                    case NORTH:
-                        return Side.TOP;
-                    case SOUTH:
-                        return Side.BOTTOM;
-                    case TOP:
-                        return Side.SOUTH;
-                    case BOTTOM:
-                        return Side.NORTH;
-                    default:
-                        return side;
-                }
-            case DOWN:
-                switch (side) {
-                    case NORTH:
-                        return Side.TOP;
-                    case SOUTH:
-                        return Side.BOTTOM;
-                    case TOP:
-                        return Side.NORTH;
-                    case BOTTOM:
-                        return Side.SOUTH;
-                    default:
-                        return side;
-                }
-        }
-        return Side.BOTTOM;
+        return switch (dir) { // I love brute forcing fixes so much :3
+            case SOUTH -> side;
+            case EAST -> side.getDirection().rotate(1).getSide();
+            case NORTH -> side.getDirection().rotate(2).getSide();
+            case WEST -> side.getDirection().rotate(3).getSide();
+            case UP -> switch (side) {
+                case NORTH -> Side.TOP;
+                case SOUTH -> Side.BOTTOM;
+                case TOP -> Side.SOUTH;
+                case BOTTOM -> Side.NORTH;
+                default -> side;
+            };
+            case DOWN -> switch (side) {
+                case NORTH -> Side.TOP;
+                case SOUTH -> Side.BOTTOM;
+                case TOP -> Side.NORTH;
+                case BOTTOM -> Side.SOUTH;
+                default -> side;
+            };
+            default -> Side.BOTTOM;
+        };
     }
 }
